#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=1.ico
#AutoIt3Wrapper_Outfile=Smartclip_32 bit.exe
#AutoIt3Wrapper_Outfile_x64=Smartclip_64 bit.exe
#AutoIt3Wrapper_Compile_Both=y
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****

If _Singleton("Smartclip", 1) = 0 Then
	MsgBox(4144, "Warnung", "Script wird beendet da schon eine" & @CRLF & "Instanz davon aktiv ist" & @CRLF & "Erkennbar am grnen Kreuz im Systemtray")
	Exit
EndIf


TraySetIcon("1.ico")
;MsgBox(4096, "Meldung", @AutoItX64)
#cs
	Version 1.68
	Erstellt unter autoit Portable 3.3.12.0 am 19 Juli 2017
	Author: Tuxedo auf Autoit.de
	F1 - zeigt die verfgbaren Tastenkombination fr 4 Sekunden an.
	Ausfhrliche Anleitung in der beiligenden Smartclip_Handbuch.rtf
	Das Programm funktioniert sehr einfach, es knnen Text-Abschnitte Hyper-Links und Grafiken(allerdings nur solche
	die einen Link besitzen und vom Typ GIF JPG PNG sind) kopiert und wieder eingefgt werden.
	Im gesamten reagiert das Programm auf Vernderungen im Clipboard - Zwischenablage und auf CTRL+c und CTRL+v

	Da es Seiten gibt die beim Bilder kopieren Probleme machen, habe ich zustzlich eine Meldung eingebaut die
	erscheint wenn keine Bild-Kopie mglich ist und gleichzeitig wird im gespeicherten Clipboardeintrag statt
	des Bildes ein Hinweis und der Link zum Bild eingefgt, damit nach dem Einfgen auch sieht wo das Bild sein sollte.
	Dann kann es einfach manuell im Browser geladen und hndisch kopiert werden, oder man macht es einfach so wie man es
	im Browser ohne das Tool machen wrde(Grafik kopieren+einfgen oder Bild aufrufen und Drag and Drop).

	Die Code-Teile um das Bild ins Clipboard zu bringen stammen vom User "UEZ" auf Autoit.de Herzlichen Dank an "UEZ"
	weitere Hilfe von @Alpines @autoiter und @Musashi alle auf autoit.de zuhause.
#ce


#include <Clipboard.au3>
#include <Gdiplus.au3>


HotKeySet("{F1}", "F_Hilfe")
HotKeySet("{F2}", "F_Ende")
HotKeySet("{F3}", "F_DelArray")
HotKeySet("^!p", "F_Pause")
HotKeySet("^c", "F_Kopieren")
HotKeySet("^v", "F_Einfuegen")


$Anzahl = 20
If @Compiled = True Then
	$Anzahl = Number(StringRight(@ScriptName, 6) - StringRight(@ScriptName, 4))
	If @error Then $Anzahl = Null
	If $Anzahl < 5 Or $Anzahl > 50 Then $Anzahl = 20
EndIf


Dim $Clip[$Anzahl]
Dim $Cstep = 0, $Vstep = 0, $Bild, $TimerKurz, $TimerLang, $TimerExtraLang, $Aktiv = True, $Del = True
$hUser32 = DllOpen("user32.dll")
F_Hilfe()


ClipPut("")
While 1
	While $Aktiv = False
		ToolTip("Smartclip wird pausiert", MouseGetPos(0) + 100, MouseGetPos(1) - 30, "Toggle Pause mit ALT+p")
		Sleep(500)
	WEnd

	If ClipGet() <> "" And Not _IsPressed("11", $hUser32) Then F_LinkCopy()
	;If _IsPressed("11", $hUser32) And Not ClipGet() = "" Then F_BildCopy()
	If _IsPressed("11", $hUser32) And ClipGet() <> "" Then F_BildCopy()

	If TimerDiff($TimerKurz) > 1300 And TimerDiff($TimerKurz) < 1800 Then SplashOff()
	If TimerDiff($TimerLang) > 2500 And TimerDiff($TimerLang) < 3000 Then SplashOff()
	If TimerDiff($TimerExtraLang) > 4000 And TimerDiff($TimerExtraLang) < 4500 Then SplashOff()
	Sleep(200)
WEnd


Func F_LinkCopy()
	If $Cstep > UBound($Clip) - 1 Then
		SplashTextOn("Warnung", '"Keine Clips mehr verfgbar' & @CRLF & 'Weitermachen mit "EINFGEN"', 250, 120, MouseGetPos(0), MouseGetPos(1), 16, "Arial", 14, 400)
		$TimerLang = TimerInit()
		ClipPut("")
		Return
	EndIf
	$Clip[$Cstep] = ClipGet()
	SplashTextOn("Titel", "Clip " & $Cstep & " wurde gespeichert", 270, 50, MouseGetPos(0), MouseGetPos(1), 17, "Arial", 14, 400)
	$TimerKurz = TimerInit()
	$Cstep += 1
	ClipPut("")
EndFunc   ;==>F_LinkCopy


Func F_BildCopy()
	$Del = True
	If $Cstep > UBound($Clip) - 1 Then
		SplashTextOn("Warnung", '"Keine Clips mehr verfgbar' & @CRLF & 'Weitermachen mit "EINFGEN"', 250, 120, MouseGetPos(0), MouseGetPos(1), 16, "Arial", 14, 400)
		$TimerLang = TimerInit()
		ClipPut("")
		Return
	EndIf

	$Url = ClipGet()
	;MsgBox(4096, "Meldung", $Url)

	#Region Neuer BildladeBlock
	;Run(@ComSpec & " /c """ & @ScriptDir & "\cURLBin\curl.exe https://autoit.de/wcf/images/avatars/9f/1244-9f9981b4e9abbb446b1b6a70a4ad23868bca9c29.gif >> " & @ScriptDir & "\autoit-5.gif""")
	;RunWait(@ComSpec & " /c """ & @ScriptDir & "\curl.exe "&$Url&" >> " & @ScriptDir & "\Bild""", "", @SW_HIDE)
	;RunWait(@ComSpec & " /c """ & "curl.exe "&$Url&" >> " & "Bild""", "", @SW_HIDE);funzt nicht in Compiled Script
	RunWait(@ComSpec & " /c """ & '"' & @ScriptDir & '"' & "\curl.exe " & $Url & " >> " & '"' & @ScriptDir & '"' & "\Bild""", "", @SW_HIDE)

	$Clip[$Cstep] = Binary(FileRead(@ScriptDir & "\Bild"))
	Sleep(200)
	FileDelete(@ScriptDir & "\Bild")
	#EndRegion Neuer BildladeBlock

	#Region Alter BildladeBlock
;~ 	$ClearID = "8"
;~ 	Run("RunDll32.exe InetCpl.cpl,ClearMyTracksByProcess " & $ClearID)
;~ 	HttpSetUserAgent("Mozilla/5.0 (Windows NT 6.1; WOW64; rv:40.0) Gecko/20100101 Firefox/40.1")
;~ 	$Clip[$Cstep] = InetRead($Url, 18);Gibt dir Binary vom Bild
	#EndRegion Alter BildladeBlock

	;MsgBox(4096, "Meldung", StringLeft($Clip[$Cstep], 10))
	If StringLeft($Clip[$Cstep], 10) = "0x89504E47" Then $Del = False;0x89504E47 = .PNG
	If StringLeft($Clip[$Cstep], 10) = "0xFFD8FFE0" Then $Del = False;0xFFD8FFE0 = .JPG
	If StringLeft($Clip[$Cstep], 8) = "0x474946" Then $Del = False;0x474946 = .GIF
	;If StringLeft($Clip[$Cstep], 8) = "0x1F8B08" Then $Del = False;0x1F8B08 = .ICO
	;If StringLeft($Clip[$Cstep],10 = ".JPEG") Then $Del = False;0x89504E47 = .JPEG
	;If StringLeft($Clip[$Cstep],10 = ".BMP") Then $Del = False;0x89504E47 = .BMP
	;If StringLeft($Clip[$Cstep],10 = ".TIF") Then $Del = False;0x89504E47 = .TIF
	If $Del Then $Clip[$Cstep] = ""
	If $Clip[$Cstep] = "" Then
		MsgBox(4096, "Meldung", "Download-Fehler" & @CRLF & "Das Bild muss hndisch geladen werden")
		$Clip[$Cstep] = 'Folgendes Bild muss von Hand nachgeladen werden' & @CRLF & 'Am Besten per "Grafik kopieren" oder "Drag and Drop"' & @CRLF & $Url
	EndIf
	;MsgBox(4096, "Meldung", $Clip[$Cstep])


	SplashTextOn("Titel", "Clip " & $Cstep & " wurde gespeichert", 270, 50, MouseGetPos(0), MouseGetPos(1), 17, "Arial", 14, 400)
	$TimerKurz = TimerInit()
	$Cstep += 1
	ClipPut("")
EndFunc   ;==>F_BildCopy


Func F_Kopieren()
	If $Cstep > UBound($Clip) - 1 Then
		SplashTextOn("Warnung", '"Keine Clips mehr verfgbar' & @CRLF & 'Weitermachen mit "EINFGEN"', 250, 120, MouseGetPos(0), MouseGetPos(1), 16, "Arial", 16, 700)
		$TimerLang = TimerInit()
		ClipPut("")
		Sleep(50)
		Return
	EndIf
	;Send("{CTRL UP}")
	HotKeySet("^c")
	;Sleep(50)
	Send("^c")
	Sleep(100);Diese Zeile ist sehr wichtig, sonst wird stndig F_BildCopy statt F_Kopieren aufgerufen
	If ClipGet() <> "" Then;Da ich hier ndern musste kann jetzt der gleiche Einrtag mehrmals kopiert werden
		;Sleep(30);Bei einem zweiten Durchgang wird ohne diesen Sleep der Clip[0] als Leerstring gespeichert k.A. warum??

		$Clip[$Cstep] = ClipGet()

		SplashTextOn("Titel", "Clip " & $Cstep & " wurde gespeichert", 270, 50, MouseGetPos(0), MouseGetPos(1), 17, "Arial", 14, 400)
		$TimerKurz = TimerInit()
		$Cstep += 1
	EndIf
	ClipPut("")
	;Sleep(50)
	HotKeySet("^c", "F_Kopieren")

EndFunc   ;==>F_Kopieren


Func F_Einfuegen()
	HotKeySet("^v")
	If $Vstep >= $Cstep Then
		$Vstep = 0
		$Cstep = 0
		SplashTextOn("Titel", "Alles eingefgt + Reset" & @CRLF & "Script wieder kopierbereit", 270, 120, MouseGetPos(0), MouseGetPos(1), 16, "Arial", 16, 700)
		$TimerLang = TimerInit()
		ClipPut("")
		HotKeySet("^v", "F_Einfuegen")
		Return
	EndIf


	;MsgBox(4096, "Meldung", StringLeft($Clip[$Vstep],10))
	If StringLeft($Clip[$Vstep], 10) = "0x89504E47" Then Return F_BildEinfuegen();0x89504E47 = .PNG
	If StringLeft($Clip[$Vstep], 10) = "0xFFD8FFE0" Then Return F_BildEinfuegen();0xFFD8FFE0 = .JPG
	If StringLeft($Clip[$Vstep], 10) = "0x3C21444F" Then Return F_BildEinfuegen();0x3C21444F = .JPG
	If StringLeft($Clip[$Vstep], 8) = "0x474946" Then Return F_BildEinfuegen();0x474946 = .GIF
	;If StringLeft($Clip[$Vstep], 8) = "0x1F8B08" Then Return F_BildEinfuegen();0x1F8B08 = .ICO
	;If StringLeft($Clip[$Vstep],10 = ".JPEG") Then Return F_BildEinfuegen();0x89504E47 = .JPEG
	;If StringLeft($Clip[$Vstep],10 = ".BMP") True Then Return F_BildEinfuegen();0x89504E47 = .BMP
	;If StringLeft($Clip[$Vstep],10 = ".TIF") Then Return F_BildEinfuegen();0x89504E47 = .TIF
	ClipPut($Clip[$Vstep])
	Send("^v")
	SplashTextOn("Titel", "Clip " & $Vstep & " von " & $Cstep - 1 & " wurde eingefgt ", 270, 50, MouseGetPos(0), MouseGetPos(1), 17, "Arial", 14, 400)
	$TimerKurz = TimerInit()
	$Clip[$Vstep] = ""
	ClipPut("")
	$Vstep += 1
	HotKeySet("^v", "F_Einfuegen")
EndFunc   ;==>F_Einfuegen



Func F_BildEinfuegen()
	HotKeySet("^v")
	;<== UEZ
	_GDIPlus_Startup();dieser ganze Block stammt von UEZ
	$hBild = _GDIPlus_BitmapCreateFromMemory($Clip[$Vstep], True) ;erstellt dir ein GDI Bitmap vom InetRead.
	$hClipboard_Bild = _WinAPI_CopyImage($hBild, 0, 0, 0, BitOR($LR_COPYDELETEORG, $LR_COPYRETURNORG))
	_ClipBoard_Open(0)
	_ClipBoard_Empty()
	_ClipBoard_SetDataEx($hClipboard_Bild, $CF_BITMAP)
	_ClipBoard_Close()
	_WinAPI_DeleteObject($hBild)
	_WinAPI_DeleteObject($hClipboard_Bild)
	_GDIPlus_Shutdown()
	;==> UEZ
	Send("^v")
	Sleep(500)
	If $Vstep >= $Cstep Then
		$Vstep = 0
		$Cstep = 0
		SplashTextOn("Titel", "Alles eingefgt + Reset" & @CRLF & "Script wieder kopierbereit", 250, 120, MouseGetPos(0), MouseGetPos(1), 16, "Arial", 16, 700)
		$TimerLang = TimerInit()
		ClipPut("")
		HotKeySet("^v", "F_Einfuegen")
		Return
	EndIf

	HotKeySet("^v", "F_Einfuegen")
	SplashTextOn("Titel", "Clip " & $Vstep & " von " & $Cstep - 1 & " wurde eingefgt ", 270, 50, MouseGetPos(0), MouseGetPos(1), 17, "Arial", 14, 400)
	$TimerKurz = TimerInit()
	$Clip[$Vstep] = ""
	ClipPut("")
	$Vstep += 1
EndFunc   ;==>F_BildEinfuegen


Func F_DelArray()
	SplashTextOn("Titel", "Reset wird durchgefhrt", 250, 50, MouseGetPos(0), MouseGetPos(1), 16, "Arial", 14, 400)
	$TimerLang = TimerInit()
	;_ArrayDelete ist nicht brauchbar da nicht nur der Array-Inhalt gelscht wird

	For $i = 0 To UBound($Clip) - 1
		$Clip[$i] = ""
	Next

	$Cstep = 0
	$Vstep = 0
	ClipPut("")
EndFunc   ;==>F_DelArray


Func F_Pause()
	ClipPut("")
	ToolTip("")
	SplashOff()
	$Aktiv = Not $Aktiv
	If $Aktiv = True Then
		HotKeySet("^c", "F_Kopieren")
		HotKeySet("^v", "F_Einfuegen")
	Else
		HotKeySet("^c")
		HotKeySet("^v")
	EndIf
EndFunc   ;==>F_Pause


Func F_Hilfe()
	SplashTextOn("Titel", "F1 - Hilfe anzeigen" & @CRLF & "F2 - Programm Beenden" & @CRLF & "F3 - Reset Daten Lschen" & @CRLF & "CTRL+ALT+p - Pause" & @CRLF & "Ctrl+c - Kopieren" & @CRLF & "CTRL+v - Einfgen", 300, 150, MouseGetPos(0), MouseGetPos(1), 37, "arial", 14, 600)
	$TimerExtraLang = TimerInit()
EndFunc   ;==>F_Hilfe


Func _IsPressed($sHexKey, $vDLL = 'user32.dll')
	; $hexKey must be the value of one of the keys.
	; _Is_Key_Pressed will return 0 if the key is not pressed, 1 if it is.
	Local $a_R = DllCall($vDLL, "short", "GetAsyncKeyState", "int", '0x' & $sHexKey)
	If @error Then Return SetError(@error, @extended, False)
	Return BitAND($a_R[0], 0x8000) <> 0
EndFunc   ;==>_IsPressed


; #FUNCTION# ====================================================================================================================
; Author ........: Valik
; Modified.......:
; ===============================================================================================================================
Func _Singleton($sOccurenceName, $iFlag = 0)
	Local Const $ERROR_ALREADY_EXISTS = 183
	Local Const $SECURITY_DESCRIPTOR_REVISION = 1
	Local $tSecurityAttributes = 0

	If BitAND($iFlag, 2) Then
		; The size of SECURITY_DESCRIPTOR is 20 bytes.  We just
		; need a block of memory the right size, we aren't going to
		; access any members directly so it's not important what
		; the members are, just that the total size is correct.
		Local $tSecurityDescriptor = DllStructCreate("byte;byte;word;ptr[4]")
		; Initialize the security descriptor.
		Local $aRet = DllCall("advapi32.dll", "bool", "InitializeSecurityDescriptor", _
				"struct*", $tSecurityDescriptor, "dword", $SECURITY_DESCRIPTOR_REVISION)
		If @error Then Return SetError(@error, @extended, 0)
		If $aRet[0] Then
			; Add the NULL DACL specifying access to everybody.
			$aRet = DllCall("advapi32.dll", "bool", "SetSecurityDescriptorDacl", _
					"struct*", $tSecurityDescriptor, "bool", 1, "ptr", 0, "bool", 0)
			If @error Then Return SetError(@error, @extended, 0)
			If $aRet[0] Then
				; Create a SECURITY_ATTRIBUTES structure.
				$tSecurityAttributes = DllStructCreate($tagSECURITY_ATTRIBUTES)
				; Assign the members.
				DllStructSetData($tSecurityAttributes, 1, DllStructGetSize($tSecurityAttributes))
				DllStructSetData($tSecurityAttributes, 2, DllStructGetPtr($tSecurityDescriptor))
				DllStructSetData($tSecurityAttributes, 3, 0)
			EndIf
		EndIf
	EndIf

	Local $aHandle = DllCall("kernel32.dll", "handle", "CreateMutexW", "struct*", $tSecurityAttributes, "bool", 1, "wstr", $sOccurenceName)
	If @error Then Return SetError(@error, @extended, 0)
	Local $aLastError = DllCall("kernel32.dll", "dword", "GetLastError")
	If @error Then Return SetError(@error, @extended, 0)
	If $aLastError[0] = $ERROR_ALREADY_EXISTS Then
		If BitAND($iFlag, 1) Then
			DllCall("kernel32.dll", "bool", "CloseHandle", "handle", $aHandle[0])
			If @error Then Return SetError(@error, @extended, 0)
			Return SetError($aLastError[0], $aLastError[0], 0)
		Else
			Exit -1
		EndIf
	EndIf
	Return $aHandle[0]
EndFunc   ;==>_Singleton


Func F_Ende()
	DllClose($hUser32)
	Exit
EndFunc   ;==>F_Ende

